#include <stdio.h>
#include <mysql.h>
#include <WINGs.h>
#include <locale.h>

#include "appicon.xpm"

#include "search.xpm"
#include "new.xpm"
#include "first.xpm"
#include "prev.xpm"
#include "next.xpm"
#include "last.xpm"
#include "save.xpm"
#include "delete.xpm"
#include "quit.xpm"
#include "up.xpm"
#include "down.xpm"
#include "setup.xpm"
#include "email.xpm"
#include "www.xpm"

#include "connection.h"
// #include "fileaccess.h"

#define fieldused(x)	(dummyrow[x] && (strcmp(dummyrow[x], "") > 0))

int main (int argc, char **argv) {
	MYSQL daten, *sock;
	MYSQL_RES *res;
	MYSQL_ROW zeile;
	char query[2000], lastsearch[50], activeemail[100], activewww[100];

	Display *dpy;
	WMWindow *win;
	WMScreen *scr;
	WMLabel *phonelabel, *addresslabel, *statuslabel, *birthlabel;
	WMFrame *cardframe;
	WMButton *querybutton,
		 *sizebutton,
		 *setupbutton,
		 *emailbutton,
		 *wwwbutton,
		 *newbutton,
		 *firstbutton,
		 *prevbutton,
		 *nextbutton,
		 *lastbutton,
		 *savebutton,
		 *deletebutton,
		 *quitbutton;
	WMList *datalist;
	WMArray *keys;
	WMTextField *namefield,
		    *phone1field,
		    *phone2field,
		    *phone3field,
		    *streetfield,
		    *placefield,
		    *birthfield;
	int bigsize = 0, largestnumber;

	void clearfields() {
		WMSetTextFieldText(namefield, "");
		WMSetTextFieldText(phone1field, "");
		WMSetTextFieldText(phone2field, "");
		WMSetTextFieldText(phone3field, "");
		WMSetTextFieldText(streetfield, "");
		WMSetTextFieldText(placefield, "");
		strcpy(activeemail, "");
		strcpy(activewww, "");
		WMSetTextFieldText(birthfield, "");

		WMSetBalloonTextForView(activeemail, WMWidgetView(emailbutton));
		WMSetBalloonTextForView(activewww, WMWidgetView(wwwbutton));

		WMSetLabelText(statuslabel, "(no data)");
	}

	void showrow(WMWidget *self, void *data) {
		char buffer[500];
		MYSQL_ROW dummyrow;

		mysql_init(&daten);
		if(!(sock = mysql_connect(&daten, HOST, USER, PASS))) {
			fprintf(stderr, "connection to database failed.\n\n");
			exit(1);
		}

		if(mysql_select_db(&daten, BASE)) {
			fprintf(stderr, "could not select base.\n\n");
			exit(1);
		}

		sprintf(buffer, "SELECT * FROM %s WHERE number = %d", TABLE, (int)WMGetFromArray(keys, WMGetListSelectedItemRow(datalist)));
		mysql_query(sock, buffer);
		res = mysql_store_result(sock);
		dummyrow = mysql_fetch_row(res);
		mysql_free_result(res);
		mysql_close(&daten);

		if(fieldused(1)) WMSetTextFieldText(namefield, dummyrow[1]); else WMSetTextFieldText(namefield, "");
		if(fieldused(2)) WMSetTextFieldText(phone1field, dummyrow[2]); else WMSetTextFieldText(phone1field, "");
		if(fieldused(3)) WMSetTextFieldText(phone2field, dummyrow[3]); else WMSetTextFieldText(phone2field, "");
		if(fieldused(4)) WMSetTextFieldText(phone3field, dummyrow[4]); else WMSetTextFieldText(phone3field, "");
		if(fieldused(5)) WMSetTextFieldText(streetfield, dummyrow[5]); else WMSetTextFieldText(streetfield, "");
		if(fieldused(6)) WMSetTextFieldText(placefield, dummyrow[6]); else WMSetTextFieldText(placefield, "");
		if(fieldused(7)) strcpy(activeemail, dummyrow[7]); else strcpy(activeemail, "");
		if(fieldused(8)) strcpy(activewww, dummyrow[8]); else strcpy(activewww, "");
		if(fieldused(9) && strcmp(dummyrow[9], "0000-00-00")) WMSetTextFieldText(birthfield, dummyrow[9]); else WMSetTextFieldText(birthfield, "0000-00-00");

		/*createRecord(dummyrow[1], dummyrow[2], dummyrow[3], dummyrow[4],
				dummyrow[5], dummyrow[6], dummyrow[7], dummyrow[8],
				dummyrow[9]);*/

		WMSetBalloonTextForView(activeemail, WMWidgetView(emailbutton));
		WMSetBalloonTextForView(activewww, WMWidgetView(wwwbutton));

		if(strcmp(lastsearch, "") > 0) {
			sprintf(query, "Search for: '%s' -- Result %d of %d", lastsearch, WMGetListSelectedItemRow(datalist)+1, WMGetListNumberOfRows(datalist));
		} else {
			sprintf(query, "Record %d of %d", WMGetListSelectedItemRow(datalist)+1, WMGetListNumberOfRows(datalist));
		}
		WMSetLabelText(statuslabel, query);

		WMSetFocusToWidget(nextbutton);
	}

	int querybase(char *condition) {
		WMEmptyArray(keys);
		WMClearList(datalist);
		largestnumber = 0;

		mysql_init(&daten);
		if(!(sock = mysql_connect(&daten, HOST, USER, PASS))) {
			sprintf(query,"aaargh!\n\nconnection to db failed.");
			WMRunAlertPanel(scr, win, "database error", query, "close", NULL, NULL);
			return -1;
		}

		if(mysql_select_db(&daten, BASE)) {
			sprintf(query,"aaargh!\n\n%s", mysql_error(sock));
			WMRunAlertPanel(scr, win, "database error", query, "close", NULL, NULL);
			return -1;
		}

		if(condition) {
			strcpy(lastsearch, condition);
			sprintf(query, "SELECT * FROM %s WHERE name LIKE '%%%s%%' ORDER BY 2", TABLE, condition);
		} else {
			strcpy(lastsearch, "");
			sprintf(query, "SELECT * FROM %s ORDER BY 2", TABLE);
		}

		mysql_query(sock, query);
		if(!(res = mysql_store_result(sock)))
		{
			sprintf(query,"aaargh!\n\n%s", mysql_error(sock));
			WMRunAlertPanel(scr, win, "database error", query, "close", NULL, NULL);
			return -1;
		}

		while (zeile = mysql_fetch_row(res)) {
			if(atoi(zeile[0])>largestnumber) largestnumber = atoi(zeile[0]);
			WMAddListItem(datalist, zeile[1]);
			WMAddToArray(keys, (int*)atoi(zeile[0]));
		}

		mysql_free_result(res);
		mysql_close(sock);

		if(((WMGetListNumberOfRows(datalist) > 1) && !bigsize) || 
		   ((WMGetListNumberOfRows(datalist) < 2) && bigsize))
			WMPerformButtonClick(sizebutton);

		WMSetLabelText(statuslabel, "---");
		return 1;
	}

	void quit(WMWidget *self, void *data) {
		exit(0);
	}

	void jumptorow(int whatrow) {
		if (WMGetListNumberOfRows(datalist) < 1) {
			clearfields();
		} else {
			if(whatrow > WMGetListNumberOfRows(datalist)-1)
				whatrow = WMGetListNumberOfRows(datalist)-1;
			WMSelectListItem(datalist, whatrow);
			if(WMGetListSelectedItemRow(datalist) < WMGetListPosition(datalist)) {
				WMSetListPosition(datalist, WMGetListSelectedItemRow(datalist));
			}
			if(WMGetListSelectedItemRow(datalist) > WMGetListPosition(datalist) + 14) {
				WMSetListPosition(datalist, WMGetListSelectedItemRow(datalist));
			}
			showrow(NULL, NULL);
		}
	}

	void jumptonumber(int whatnumber) {
		int i;
		for(i=0; i < WMGetListNumberOfRows(datalist); i++) {
			if((int)WMGetFromArray(keys,i) == whatnumber) {
				jumptorow(i);
			}
		}
	}

	void searchfor(WMWidget *self, void *data) {
		char *result = WMRunInputPanel(scr, win, "search", "leave blank to get the whole list.", lastsearch, "okay", "cancel");
		if(result) {
			querybase(result);
			//showrow(NULL, NULL);
			jumptorow(0);
		}
	}

	void firstaddress(WMWidget *self, void *data) {
		WMSetListPosition(datalist, 0);
		WMSelectListItem(datalist, 0);
		showrow(self, data);
	}

	void lastaddress(WMWidget *self, void *data) {
		WMSelectListItem(datalist, WMGetListNumberOfRows(datalist)-1);
		WMSetListPosition(datalist, WMGetListNumberOfRows(datalist)-1);
		showrow(self, data);
	}

	void prevaddress(WMWidget *self, void *data) {
		if(WMGetListSelectedItemRow(datalist) > 0) {
			WMSelectListItem(datalist, WMGetListSelectedItemRow(datalist)-1);
			if(WMGetListSelectedItemRow(datalist) < WMGetListPosition(datalist)) {
				WMSetListPosition(datalist, WMGetListSelectedItemRow(datalist));
			}
			if(WMGetListSelectedItemRow(datalist) > WMGetListPosition(datalist) + 14) {
				WMSetListPosition(datalist, WMGetListSelectedItemRow(datalist));
			}
			showrow(self, data);
		}
	}

	void nextaddress(WMWidget *self, void *data) {
		if(WMGetListSelectedItemRow(datalist) < WMGetListNumberOfRows(datalist)-1) {
			WMSelectListItem(datalist, WMGetListSelectedItemRow(datalist)+1);
			if(WMGetListSelectedItemRow(datalist) < WMGetListPosition(datalist)) {
				WMSetListPosition(datalist, WMGetListSelectedItemRow(datalist) - 14);
			}
			if(WMGetListSelectedItemRow(datalist) > WMGetListPosition(datalist) + 14) {
				WMSetListPosition(datalist, WMGetListSelectedItemRow(datalist) - 14);
			}
			showrow(self, data);
		}
	}

	char *removedummy(char *string) {
		if(strcmp(string, "(no data)") == 0) return ""; else return string;
	}

	void saveaddress(WMWidget *self, void *data) {
		int activenumber = (int)WMGetFromArray(keys, WMGetListSelectedItemRow(datalist));
		mysql_init(&daten);
		if(!(sock = mysql_connect(&daten, HOST, USER, PASS))) {
			WMRunAlertPanel(scr, win, "error.", "connection to database failed.", "close", NULL, NULL);
		} else {
			if(mysql_select_db(&daten, BASE)) {
				WMRunAlertPanel(scr, win, "error.", "could not select base.", "close", NULL, NULL);
			} else {
				sprintf(query, "UPDATE %s SET name=\"%s\",phone1=\"%s\",phone2=\"%s\",phone3=\"%s\",street=\"%s\",place=\"%s\",email=\"%s\",homepage=\"%s\",birthday=\"%s\" WHERE number = %d", TABLE,
					WMGetTextFieldText(namefield),
					WMGetTextFieldText(phone1field),
					WMGetTextFieldText(phone2field),
					WMGetTextFieldText(phone3field),
					WMGetTextFieldText(streetfield),
					WMGetTextFieldText(placefield),
					activeemail,
					activewww,
					WMGetTextFieldText(birthfield), activenumber);
				if(mysql_query(sock, query)) {
					sprintf(query, "aaargh!\n\n%s", mysql_error(sock));
					WMRunAlertPanel(scr, win, "error.", query, "close", NULL, NULL);
					showrow(self, data);
				}
				mysql_close(sock);
			}
		}
		querybase("");
		jumptonumber(activenumber);
	}

	void deleteaddress(WMWidget *self, void *data) {
		int activerow;
		mysql_init(&daten);
		if(!(sock = mysql_connect(&daten, HOST, USER, PASS))) {
			WMRunAlertPanel(scr, win, "error.", "connection to database failed.", "close", NULL, NULL);
		} else {
			if(mysql_select_db(&daten, BASE)) {
				WMRunAlertPanel(scr, win, "error.", "could not select base.", "close", NULL, NULL);
			} else {
				sprintf(query, "DELETE FROM %s WHERE number = %d", TABLE, (int)WMGetFromArray(keys, WMGetListSelectedItemRow(datalist)));
				if(mysql_query(sock, query)) {
					sprintf(query, "aaargh!\n\n%s", mysql_error(sock));
					WMRunAlertPanel(scr, win, "error.", query, "close", NULL, NULL);
					showrow(self, data);
				}
				activerow = WMGetListSelectedItemRow(datalist);
				mysql_close(sock);
			}
		}
		querybase(lastsearch);
		jumptorow(activerow);
	}

	void newaddress(WMWidget *self, void *data) {
		mysql_init(&daten);
		if(!(sock = mysql_connect(&daten, HOST, USER, PASS))) {
			WMRunAlertPanel(scr, win, "error.", "connection to database failed.", "close", NULL, NULL);
		} else {
			if(mysql_select_db(&daten, BASE)) {
				WMRunAlertPanel(scr, win, "error.", "could not select base.", "close", NULL, NULL);
			} else {
				sprintf(query, "INSERT INTO %s SET name=\"New Entry\"", TABLE);
				if(mysql_query(sock, query)) {
					sprintf(query, "aaargh!\n\n%s", mysql_error(sock));
					WMRunAlertPanel(scr, win, "error.", query, "close", NULL, NULL);
					showrow(self, data);
				}
				mysql_close(sock);
			}
		}
		querybase("");
		jumptonumber(largestnumber);
	}

	void changeemail(WMWidget *self, void *data) {
		char *result = WMRunInputPanel(scr, win, "email address", "don't forget to save!", activeemail, "okay", "cancel");
		if(result) {
			strcpy(activeemail, result);
			WMSetBalloonTextForView(activeemail, WMWidgetView(emailbutton));
		}
	}

	void changewww(WMWidget *self, void *data) {
		char *result = WMRunInputPanel(scr, win, "homepage address", "don't forget to save!", activewww, "okay", "cancel");
		if(result) {
			strcpy(activewww, result);
			WMSetBalloonTextForView(activewww, WMWidgetView(wwwbutton));
		}
	}

	void changesize(WMWidget *self, void *data) {
		if(bigsize) {
			WMResizeWidget(win, 280, 217);
			WMSetButtonImage(sizebutton, WMCreatePixmapFromXPMData(scr, down_xpm));
			bigsize = 0;
		} else {
			WMResizeWidget(win, 280, 460);
			WMSetButtonImage(sizebutton, WMCreatePixmapFromXPMData(scr, up_xpm));
			bigsize = 1;
		}
	}

	void SizeChanged(void *self, WMNotification *notif) {
		//exit(1);
		//printf(".");
	}

	setlocale(LC_ALL, "");
	keys = WMCreateArray(1);

	WMInitializeApplication("wingman", &argc, argv);
	dpy = XOpenDisplay("");
	if(!dpy) {
		printf("could not open display.");
		exit(1);
	}
	scr = WMCreateScreen(dpy, DefaultScreen(dpy));
	
	win = WMCreateWindow (scr, "wingman");
	WMSetWindowTitle(win, "WingMan Addressbook 0.1.1");
	WMSetWindowCloseAction(win, quit, NULL);
	WMSetWindowMinSize(win, 280, 217);
	WMSetWindowMaxSize(win, 280, 460);
	WMSetBalloonTextForView("The WingMan Addressbook 0.1.1\n\nthe interface to your personal address database.\n\n(c) 2000 by Robert Lillack", WMWidgetView(win));
	WMSetApplicationIconImage(scr, WMCreatePixmapFromXPMData(scr, appicon_xpm));

	cardframe = WMCreateFrame(win);
	WMSetWidgetBackgroundColor(cardframe, WMCreateRGBColor(scr, 222<<8, 222<<8, 222<<8, False));
	WMSetFrameRelief(cardframe, WRPushed);
	WMResizeWidget(cardframe, 260, 160);
	WMMoveWidget(cardframe, 10, 40);

	namefield = WMCreateTextField(win);
	WMSetTextFieldBordered(namefield, 0);
	WMSetTextFieldFont(namefield, WMBoldSystemFontOfSize(scr, 12));
	WMResizeWidget(namefield, 230, 16);
	WMMoveWidget(namefield, 25, 55);

	phonelabel = WMCreateLabel(win);
	WMSetLabelText(phonelabel, "Phone:");
	WMSetLabelTextAlignment(phonelabel, WARight);
	WMSetWidgetBackgroundColor(phonelabel, WMCreateRGBColor(scr, 222<<8, 222<<8, 222<<8, False));
	WMSetLabelTextColor(phonelabel, WMDarkGrayColor(scr));
	WMResizeWidget(phonelabel, 60, 16);
	WMMoveWidget(phonelabel, 25, 80);

	phone1field = WMCreateTextField(win);
	WMSetTextFieldBordered(phone1field, 0);
	WMResizeWidget(phone1field, 165, 16);
	WMMoveWidget(phone1field, 90, 80);
	phone2field = WMCreateTextField(win);
	WMSetTextFieldBordered(phone2field, 0);
	WMResizeWidget(phone2field, 165, 16);
	WMMoveWidget(phone2field, 90, 96);
	phone3field = WMCreateTextField(win);
	WMSetTextFieldBordered(phone3field, 0);
	WMResizeWidget(phone3field, 165, 16);
	WMMoveWidget(phone3field, 90, 112);

	addresslabel = WMCreateLabel(win);
	WMSetLabelText(addresslabel, "Address:");
	WMSetLabelTextAlignment(addresslabel, WARight);
	WMSetWidgetBackgroundColor(addresslabel, WMCreateRGBColor(scr, 222<<8, 222<<8, 222<<8, False));
	WMSetLabelTextColor(addresslabel, WMDarkGrayColor(scr));
	WMResizeWidget(addresslabel, 60, 16);
	WMMoveWidget(addresslabel, 25, 130);

	streetfield = WMCreateTextField(win);
	WMSetTextFieldBordered(streetfield, 0);
	WMResizeWidget(streetfield, 165, 16);
	WMMoveWidget(streetfield, 90, 130);

	placefield = WMCreateTextField(win);
	WMSetTextFieldBordered(placefield, 0);
	WMResizeWidget(placefield, 165, 16);
	WMMoveWidget(placefield, 90, 146);

	emailbutton = WMCreateCustomButton(win, WBBPushInMask);
	//WMSetButtonText(emailbutton, "@");
	WMSetButtonImage(emailbutton, WMCreatePixmapFromXPMData(scr, email_xpm));
	WMSetButtonImagePosition(emailbutton, WIPImageOnly);
	WMSetButtonAction(emailbutton, changeemail, NULL);
	WMSetWidgetBackgroundColor(emailbutton, WMCreateRGBColor(scr, 222<<8, 222<<8, 222<<8, False));
	WMSetButtonBordered(emailbutton, False);
	WMResizeWidget(emailbutton, 30, 20);
	WMMoveWidget(emailbutton, 25, 168);

	wwwbutton = WMCreateCustomButton(win, WBBPushInMask);
	WMSetButtonImage(wwwbutton, WMCreatePixmapFromXPMData(scr, www_xpm));
	WMSetButtonImagePosition(wwwbutton, WIPImageOnly);
	WMSetButtonAction(wwwbutton, changewww, NULL);
	WMSetWidgetBackgroundColor(wwwbutton, WMCreateRGBColor(scr, 222<<8, 222<<8, 222<<8, False));
	WMSetButtonBordered(wwwbutton, False);
	WMResizeWidget(wwwbutton, 30, 20);
	WMMoveWidget(wwwbutton, 55, 168);

	birthlabel = WMCreateLabel(win);
	WMSetLabelText(birthlabel, "Date of Birth:");
	WMSetLabelTextAlignment(birthlabel, WARight);
	WMSetWidgetBackgroundColor(birthlabel, WMCreateRGBColor(scr, 222<<8, 222<<8, 222<<8, False));
	WMSetLabelTextColor(birthlabel, WMDarkGrayColor(scr));
	WMResizeWidget(birthlabel, 84, 16);
	WMMoveWidget(birthlabel, 90, 170);

	birthfield = WMCreateTextField(win);
	WMSetTextFieldText(birthfield, "0000-00-00");
	WMSetTextFieldBordered(birthfield, 0);
	WMResizeWidget(birthfield, 76, 16);
	WMMoveWidget(birthfield, 179, 170);

	statuslabel = WMCreateLabel(win);
	WMSetLabelTextColor(statuslabel, WMDarkGrayColor(scr));
	WMSetLabelFont(statuslabel, WMSystemFontOfSize(scr, 10));
	WMResizeWidget(statuslabel, 200, 14);
	WMMoveWidget(statuslabel, 7, 202);

	setupbutton = WMCreateCustomButton(win, WBBPushInMask);
	WMSetButtonImage(setupbutton, WMCreatePixmapFromXPMData(scr, setup_xpm));
	WMSetButtonImagePosition(setupbutton, WIPImageOnly);
	WMSetButtonBordered(setupbutton, False);
	//WMSetButtonAction(setupbutton, changesize, NULL);
	WMSetBalloonTextForView("Change the settings for WingMan.", WMWidgetView(setupbutton));
	WMResizeWidget(setupbutton, 28, 14);
	WMMoveWidget(setupbutton, 212, 202);

	sizebutton = WMCreateCustomButton(win, WBBPushInMask);
	WMSetButtonImage(sizebutton, WMCreatePixmapFromXPMData(scr, down_xpm));
	WMSetButtonImagePosition(sizebutton, WIPImageOnly);
	WMSetButtonBordered(sizebutton, False);
	WMSetButtonAction(sizebutton, changesize, NULL);
	WMSetBalloonTextForView("Show/Hide the record list.", WMWidgetView(sizebutton));
	WMResizeWidget(sizebutton, 28, 14);
	WMMoveWidget(sizebutton, 242, 202);

	querybutton = WMCreateButton(win, WBTMomentaryPush);
	WMSetButtonImage(querybutton, WMCreatePixmapFromXPMData(scr, search_xpm));
	WMSetButtonImagePosition(querybutton, WIPImageOnly);
	WMSetButtonAction(querybutton, prevaddress, NULL);
	WMSetBalloonTextForView("Search the database.", WMWidgetView(querybutton));
	WMSetButtonAction(querybutton, searchfor, NULL);
	WMResizeWidget(querybutton, 60, 25);
	WMMoveWidget(querybutton, 10, 10);

	newbutton = WMCreateButton(win, WBTMomentaryPush);
	WMSetButtonImage(newbutton, WMCreatePixmapFromXPMData(scr, new_xpm));
	WMSetButtonImagePosition(newbutton, WIPImageOnly);
	WMSetButtonAction(newbutton, newaddress, NULL);
	WMSetBalloonTextForView("Create a new record.", WMWidgetView(newbutton));
	WMResizeWidget(newbutton, 25, 25);
	WMMoveWidget(newbutton, 70, 10);

	firstbutton = WMCreateButton(win, WBTMomentaryPush);
	WMSetButtonImage(firstbutton, WMCreatePixmapFromXPMData(scr, first_xpm));
	WMSetButtonImagePosition(firstbutton, WIPImageOnly);
	WMSetButtonAction(firstbutton, firstaddress, NULL);
	WMSetBalloonTextForView("Jump to the first record.", WMWidgetView(firstbutton));
	WMResizeWidget(firstbutton, 25, 25);
	WMMoveWidget(firstbutton, 95, 10);

	prevbutton = WMCreateButton(win, WBTMomentaryPush);
	WMSetButtonImage(prevbutton, WMCreatePixmapFromXPMData(scr, prev_xpm));
	WMSetButtonImagePosition(prevbutton, WIPImageOnly);
	WMSetButtonAction(prevbutton, prevaddress, NULL);
	WMSetBalloonTextForView("Jump to the previous record.", WMWidgetView(prevbutton));
	WMResizeWidget(prevbutton, 25, 25);
	WMMoveWidget(prevbutton, 120, 10);

	nextbutton = WMCreateButton(win, WBTMomentaryPush);
	WMSetButtonImage(nextbutton, WMCreatePixmapFromXPMData(scr, next_xpm));
	WMSetButtonImagePosition(nextbutton, WIPImageOnly);
	WMSetButtonAction(nextbutton, nextaddress, NULL);
	WMSetBalloonTextForView("Jump to the next record.", WMWidgetView(nextbutton));
	WMResizeWidget(nextbutton, 25, 25);
	WMMoveWidget(nextbutton, 145, 10);

	lastbutton = WMCreateButton(win, WBTMomentaryPush);
	WMSetButtonImage(lastbutton, WMCreatePixmapFromXPMData(scr, last_xpm));
	WMSetButtonImagePosition(lastbutton, WIPImageOnly);
	WMSetBalloonTextForView("Jump to the last record.", WMWidgetView(lastbutton));
	WMSetButtonAction(lastbutton, lastaddress, NULL);
	WMResizeWidget(lastbutton, 25, 25);
	WMMoveWidget(lastbutton, 170, 10);

	savebutton = WMCreateButton(win, WBTMomentaryPush);
	WMSetButtonImage(savebutton, WMCreatePixmapFromXPMData(scr, save_xpm));
	WMSetButtonImagePosition(savebutton, WIPImageOnly);
	WMSetButtonAction(savebutton, saveaddress, NULL);
	WMSetBalloonTextForView("Save changes to current record.", WMWidgetView(savebutton));
	WMResizeWidget(savebutton, 25, 25);
	WMMoveWidget(savebutton, 195, 10);

	deletebutton = WMCreateButton(win, WBTMomentaryPush);
	WMSetButtonImage(deletebutton, WMCreatePixmapFromXPMData(scr, delete_xpm));
	WMSetButtonImagePosition(deletebutton, WIPImageOnly);
	WMSetButtonAction(deletebutton, deleteaddress, NULL);
	WMSetBalloonTextForView("Delete current record.", WMWidgetView(deletebutton));
	WMResizeWidget(deletebutton, 25, 25);
	WMMoveWidget(deletebutton, 220, 10);

	quitbutton = WMCreateButton(win, WBTMomentaryPush);
	WMSetButtonImage(quitbutton, WMCreatePixmapFromXPMData(scr, quit_xpm));
	WMSetButtonImagePosition(quitbutton, WIPImageOnly);
	WMSetButtonAction(quitbutton, quit, NULL);
	WMSetBalloonTextForView("Quit the program.", WMWidgetView(quitbutton));
	WMResizeWidget(quitbutton, 25, 25);
	WMMoveWidget(quitbutton, 245, 10);

	datalist = WMCreateList(win);
	WMSetListAllowMultipleSelection(datalist, 0);
	WMSetListAction(datalist, showrow, NULL);
	WMResizeWidget(datalist, 260, 230);
	WMMoveWidget(datalist, 10, 220);

	WMSetViewNotifySizeChanges(WMWidgetView(win), True);
	WMAddNotificationObserver(SizeChanged, NULL, WMViewSizeDidChangeNotification, WMWidgetView(win));

	WMRealizeWidget(win);
	WMMapSubwidgets(win);
	WMMapWidget(win);

	querybase(argv[1]);
	jumptorow(0);

	WMScreenMainLoop(scr);

	WMFreeArray(keys);
	return 0;
}